# -*- coding:Utf-8 -*-
import es, gamethread, playerlib

info = es.AddonInfo()
info.name = 'zm_invisible'
info.version = '1.0'
info.author = 'Phoval'
info.url = 'http://mattie.info/forums/'
info.description = 'Invisible for zombie !'
info.tags = 'zombie;invisible'

es.ServerVar('zm_invisible_version', info.version, 'zm_invisible: Version of the zm_invisible script').makepublic()

def load():
	global joueurs, commandes, temps, nbrfois
	
	''' Dbut de la configuration, Start of configuration '''
	
	#commandes dans le chat pour qu'un zombie soit invisible, Say commands for a zombie is invisible
	commandes = ( '!inv', '!invisible' )
	# Temps pendant lequel le zombie est invisible en secondes, Time when a zombie is invisible in seconds.
	temps = 7
	# Nombre de fois qu'un zombie peut-tre invisible, Number of times a zombie perhaps invisible.
	nbrfois = 5
	
	''' Fin de la configuration, End of configuration '''
	
	joueurs = {}
	listejoueurs = es.getUseridList()
	for index in commandes:
		es.regsaycmd(index, 'zm_invisible/invisible', 'Invisibilit')
	for index in listejoueurs:
		joueurs[str(index)] = { 'now' : 0, 'fois' : 0 }

def unload():
	global joueurs, commandes
	for index in commandes:
		es.unregsaycmd(index)
	del joueurs
	del commandes

def round_start(event_var):
	global joueurs
	for userid in joueurs:
		joueurs[userid] = { 'now' : 0, 'fois' : 0 }

def player_connect(event_var):
	global joueurs
	joueurs[event_var['userid']] = { 'now' : 0, 'fois' : 0 }

def player_disconnect(event_var):
	global joueurs
	del joueurs[event_var['userid']]

def invisible():
	global joueurs, temps , nbrfois
	userid = str(es.getcmduserid())
	joueur = playerlib.getPlayer(userid)
	if joueur.attributes['teamid'] == 2:
		if joueur.attributes['isdead'] == 0:
			if joueurs[userid]['now'] == 0:
				if joueurs[userid]['fois'] < nbrfois:
					joueurs[userid]['now'] = 1
					joueurs[userid]['fois'] += 1
					if joueur.get('lang') == 'fr':
						es.menu(1, userid, 'Tu es invisible pendant '+str(temps)+' secondes ! ('+str(joueurs[userid]['fois'])+'/'+str(nbrfois)+')')
					else:
						es.menu(1, userid, 'You are invisible for '+str(temps)+' seconds ! ('+str(joueurs[userid]['fois'])+'/'+str(nbrfois)+')')
					joueur.set('color', [255, 255, 255, 0])
					es.server.cmd('es_fire '+userid+' '+joueur.attributes['weapon']+' addoutput "rendermode 1"')
					es.server.cmd('es_fire '+userid+' '+joueur.attributes['weapon']+' alpha 0')
					gamethread.delayed(temps, visible, userid)

def visible(userid):
	global joueurs
	joueurs[userid]['now'] = 0
	joueur = playerlib.getPlayer(userid)
	joueur.set('color', [255, 255, 255, 255])
	es.server.cmd('es_fire '+userid+' '+joueur.attributes['weapon']+' addoutput "rendermode 1"')
	es.server.cmd('es_fire '+userid+' '+joueur.attributes['weapon']+' alpha 255')
